function round(num)
return math.floor(num+0.5)
end

bot = {}
bot.move_dir = {}
bot.mode = {}
bot.dyn_target_x = {}
bot.dyn_target_y = {}
bot.dyn_target_x_tile = {}
bot.dyn_target_y_tile = {}
bot.item_target_x = {}
bot.item_target_y = {}
bot.follow_id = {}
bot.enity_destroyed_tolerance = {}
bot.rage = {}
bot.damage_dealt = {}
bot.best_weapon = {}
bot.ammo_left = {}

bot.setting = {}
bot.setting.min_prisoner = 5

function ai_onspawn(id)
	bot.move_dir[id] = 0
	bot.mode[id] = 1
	bot.dyn_target_x [id] = 0
	bot.dyn_target_y [id] = 0
	bot.dyn_target_x_tile [id] = 0
	bot.dyn_target_y_tile [id] = 0
	bot.item_target_x [id] = 0
	bot.item_target_y [id] = 0
	bot.enity_destroyed_tolerance [id] = 250
	bot.follow_id[id] = 0
	bot.rage[id] = 0
	bot.damage_dealt[id] = 0
	bot.best_weapon[id] = 10
	bot.ammo_left[id] = -1
end

-- bot.mode =
-- 1 search
-- 2 break wall
-- 3 roam/wait
-- 4 following
-- 5 war mode

addhook("second","bot_second")
function bot_second ()
i = 0
while (i < 32) do
i = i + 1
if player(i,"exists") and player(i,"bot") and player(i,"health") > 0 then
if bot.mode[i] < 4 then
bot_guard_found = ai_findtarget(i)
if (bot_guard_found > 0) and player(bot_guard_found,"exists") then
enemy_x = player(bot_guard_found,"tilex")
enemy_y = player(bot_guard_found,"tiley")
if math.sqrt((player(i,"tilex") - enemy_x)^2 + (player(i,"tiley") - enemy_y)^2) < 500 then
if ai_goto(i,enemy_x,enemy_y) > 0 then
bot.mode[i] = 4
bot.follow_id[i] = bot_guard_found
end
end
end
end
end
end
end

function ai_update_living(id)
	if bot.mode[id] == 1 then -- find breakable
		x = player(id,"tilex") + round (math.cos(math.rad((player(id,"rot")) - 90))*1)
		y = player(id,"tiley") + round (math.sin(math.rad((player(id,"rot")) - 90))*1)
		if (entity(x,y,"exists")) and (entity(x,y,"typename") == "Env_Breakable") then
			bot.dyn_target_x [id] = round((x*32)+16)
			bot.dyn_target_y [id] = round((y*32)+16)
			bot.dyn_target_x_tile [id] = x
			bot.dyn_target_y_tile [id] = y
			ai_selectweapon(id,50)
			bot.mode[id] = 2
		end
		result = ai_move(id,bot.move_dir[id],1) -- moves in direction 0
		ai_attack(id) -- attemp to dmg wall
		ai_rotate(id,bot.move_dir[id]-90) -- rotate in move direction - 90
		if result == 0 then -- if blocked from moving
			if bot.move_dir[id] == (90*5) then -- if direction is 0, that is first dir
				bot.mode[id] = 3
			end
			bot.move_dir[id] = bot.move_dir[id] + 90 -- turn 90 grades
		end
	end
	if bot.mode[id] == 2 then -- break breakable
		ai_aim(id,bot.dyn_target_x[id],bot.dyn_target_y[id])
		result = ai_move(id,player(id,"rot"))
		bot.enity_destroyed_tolerance [id] = bot.enity_destroyed_tolerance [id] - 1
		if bot.enity_destroyed_tolerance [id] <= 0 then
			bot.mode[id] = 3
		end
		if result == 1 then
			if not ((entity(bot.dyn_target_x_tile[id],bot.dyn_target_y_tile[id],"exists")) and (entity(bot.dyn_target_x_tile[id],bot.dyn_target_y_tile[id],"typename") == "Env_Breakable")) then
				bot.enity_destroyed_tolerance [id] = bot.enity_destroyed_tolerance [id] - 100
				if bot.enity_destroyed_tolerance [id] <= 0 then
					bot.mode[id] = 3
				end
			end
		end
		ai_attack(id)
	end
	if bot.mode[id] == 3 then -- roam
		if bot_get_ifclose_weapon(id,5) then
		ai_rotate(id,player(id,"rot")+math.random(-5,5))
			if bot_get_weapon (id) then
				if ai_move(id,player(id,"rot")) == 0 then
					ai_rotate(id,player(id,"rot")+math.random(-45,45))
				end
			end
		end
	end
	if bot.mode[id] == 4 then -- follow
		if bot.rage[id] > 100 then
			bot.mode[id] = 5
		end
		enemy_x = player(bot.follow_id[id],"x")
		enemy_y = player(bot.follow_id[id],"y")
		if bot_get_ifclose_weapon(id,5) then
			if player(bot.follow_id[id],"exists") then
				if player(bot.follow_id[id],"health") <= 0 then bot.mode[id] = 3; end
					if not(bot.follow_id[id] == ai_findtarget(id)) then bot.mode[id] = 3; end
						if math.sqrt((enemy_x - player(id,"x"))^2 + (enemy_y - player(id,"y"))^2) > 64 then
							if ai_freeline(id,enemy_x,enemy_y) then
								ai_aim(id,enemy_x,enemy_y)
								if ai_move(id,player(id,"rot")) == 0 then
									bot.mode[id] = 3
								end
							else
								if ai_move(id,player(id,"rot")) == 0 then
									bot.mode[id] = 3
								end
							end
					else
						ai_move(id,(player(id,"rot")-180)+math.random(-90,90),1)
				end
			else
				bot.mode[id] = 3
			end
		end
	end
	if bot.mode[id] == 5 then -- war mode
		if itemtype(bot.best_weapon[id],"range") > 2.5 then
			enemy_x = player(ai_findtarget(id),"x")
			enemy_y = player(ai_findtarget(id),"y")
			if ai_findtarget(id) > 0 then
				if player(ai_findtarget(id),"health") > 0 then
					if	ai_freeline(id,enemy_x,enemy_y) then
						ai_aim(id,enemy_x,enemy_y)
						ai_selectweapon(id,bot.best_weapon[id])
						ai_iattack(id)
						rot_add = 0
						if (player(id,"weapontype") == 50) == false then
							rot_add = math.random(-1,1)*90
						end
						ai_move(id,player(id,"rot")+rot_add)
						ammo_check (id)
					else
						if player(id,"weapontype") == 50 then
							bot.mode[id] = 3
						end
						ai_selectweapon(id,50)
					end
				else
					bot.mode[id] = 3
					ai_selectweapon(id,50)
				end
			else
				bot.mode[id] = 3
				ai_selectweapon(id,50)
			end
		else
			if bot.rage[id] > 200 then
				enemy_x = player(ai_findtarget(id),"x")
				enemy_y = player(ai_findtarget(id),"y")
				if ai_findtarget(id) > 0 then
					ai_aim(id,enemy_x,enemy_y)
					if math.sqrt((enemy_x - player(id,"x"))^2 + (enemy_y - player(id,"y"))^2) < 20 then
						if ai_freeline(id,enemy_x,enemy_y) then
							ai_selectweapon(id,bot.best_weapon[id])
							ai_iattack(id)
							rot_add = math.random(-1,1)*90
							ai_move(id,player(id,"rot")+rot_add)
							ammo_check (id)
						else
							ai_selectweapon(id,50)
						end
					end
				end
			else
				bot.mode[id] = 3
			end
		end
	end
end

addhook("collect","bot_collect")
function bot_collect(id,iid,item_type,ain,a,mode)
	if player(id,"bot") then
		enemy_x = player(ai_findtarget(id),"x")
		enemy_y = player(ai_findtarget(id),"y")
		if ai_findtarget(id) > 0 then
			if math.sqrt((enemy_x - player(id,"x"))^2 + (enemy_y - player(id,"y"))^2) < 500 then
				if itemtype(item_type,"dmg") > 10 then
					bot.rage[id] = bot.rage[id] + (50+(itemtype(item_type,"dmg")*2.5))
					bot.mode[i] = 5
					allbot_rage (25)
					bot.ammo_left[id] = ain+a
				end
			end
		end
		timer(10,"de_select",tostring(id))
		if itemtype(item_type,"range") > 2.5 then
			bot.best_weapon[id] = item_type
		end
	end
end

addhook("attack","bot_attack")
function bot_attack(id)
	if player(id,"bot") then
		bot.ammo_left[id] = bot.ammo_left[id] - 1
		if bot.ammo_left[id] == 0 then
			bot.mode[id] = 3
			ai_drop(id)
		end
	end
end

addhook("hit","bot_hited")
function bot_hited(id,source,weapon,hpdmg,apdmg)
	--push_back (id,source,round(hpdmg*0.25))
	if player(id,"bot") then
		if bot.best_weapon[id] == 50 then
			bot.rage[id] = bot.rage[id] + hpdmg
			allbot_rage (hpdmg*0.5)
		else
			bot.rage[id] = bot.rage[id] + hpdmg*5
			allbot_rage (hpdmg*2.5)
		end
	end
	if player(source,"bot") then
		bot.damage_dealt[source] = bot.damage_dealt[source] + hpdmg
	end
end

function push_back (id,source,push)
	x = player(id,"x")
	y = player(id,"y")
	dir = math.atan2(x - player(source,"x"),player(source,"y") - y) * 180 / math.pi
	x_add = lengthdir_x(1,dir)
	y_add = lengthdir_y(1,dir)
	push_dist = 0
	while (push_dist < push) do
		push_dist = push_dist + 1
		x = x + x_add
		y = y + y_add
		if tile(round((x-16)/32),round((y-16)/32),"walkable") then
			parse("setpos "..id.." "..x.." "..y.."")
		else
			break
		end
	end
end

addhook("die","bot_die")
function bot_die(victim,killer,weapon,x,y)
	if player(victim,"bot") then
		allbot_rage (bot.damage_dealt[victim]*0.25)
	end
end

addhook ("walkover","bot_walkover")
function bot_walkover(id,iid,wep_type,ain,a,mode)
ai_drop(id)
return 0
end

function allbot_rage (inc)
	i = 0
	while (i < 32) do
		i = i + 1
		if player(i,"exists") and player(i,"bot") then
			bot.rage[i] = bot.rage[i] + inc
			if bot.rage[i] > 100 then
				bot.mode[i] = 5
			end
		end
	end
end

function bot_get_weapon(id)
	items = closeitems(id,10)
	i = 0
	while (i < #items) do
		if ((items[i] == 61) or (items[i] == 62)) == false then
			i = i + 1
			x = item(items[i],"x")
			y = item(items[i],"y")
			if ai_goto(id,x,y) > 0 then
				return false
			end
		end
	end
	return true
end

function bot_get_ifclose_weapon(id,dist)
	items = closeitems(id,dist)
	if #items > 0 then
		x = item(items[1],"x")
		y = item(items[1],"y")
		if ai_freeline(id,(x*32)+16,(y*32)+16) then
			if ai_goto(id,x,y) > 0 then
				return false
			end
		end
	end
	return true
end

function ammo_check (id)
	-- wep = playerweapons(id)
	-- i = 0
	-- while (i < #wep) do
		-- i = i + 1
		-- iid = item(i,"type")
		-- if itemtype(iid,"slot") == 1 then
			-- if item(iid,"ammo") == 0 then
				-- bot.mode[id] = 3
				-- ai_drop(id)
			-- end
		-- end
	-- end
end

addhook ("startround","bot_startround")
function bot_startround(mode)
	t = player(0,"team1")
	temp = bot.setting.min_prisoner - #t
	i = 0
	while (i < temp) do
		i = i + 1
		parse("bot_add_t")
	end
	temp = -temp
	i = 0
	while (i < temp) do
		i = i + 1
		parse("bot_remove_t")
	end
end

addhook ("say","bot_say")
function bot_say(id,text)
	if text == "!bot_info" then
		msg("prison bot created by darkcrypt (id 5783 (usgn))")
	end
end

function de_select(id)
	ai_selectweapon(tonumber(id),50)
end

function ai_update_dead(id)
	ai_respawn(id)
end

function ai_hear_radio(source,radio)

end

function ai_hear_chat(source,msg,teamonly)

end

-- copyright darkcrypt on usgn (id 5783)